diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index 6b4afe098..55b145a16 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -41,16 +41,33 @@ public class BlockLogicSign extends BlockLogic implements IPaintable {
     }
 
     @Override
-    protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        if (!(other.getLogic() instanceof BlockLogicSign otherSign)) {
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+        assert world.getBlockType(thisPos) == this.block;
+        if (world.getBlockType(thatPos) != this.block) return false;
+        if (((world.getBlockData(thisPos) ^ world.getBlockData(thatPos)) & ~MASK_SIDE) != 0) return false;
+        if (!(world.getTileEntity(thisPos) instanceof TileEntitySign thisSign) ||
+            !(world.getTileEntity(thatPos) instanceof TileEntitySign thatSign))
             return false;
+        if (thisSign.getPicture() != thatSign.getPicture()) return false;
+
+        boolean isAllBlank = true;
+        assert thisSign.signText.length == 4 && thatSign.signText.length == 4;
+        for (int i = 0; i < 4; i++) {
+            final boolean thisIsBlank, thatIsBlank; {
+                thisIsBlank = thisSign.signText[i].isEmpty() || thisSign.signText[i].isBlank();
+                thatIsBlank = thatSign.signText[i].isEmpty() || thatSign.signText[i].isBlank();
+            }
+            if (thisIsBlank != thatIsBlank) return false;
+            if (!thisIsBlank) isAllBlank = false;
         }
-        return otherSign.isFreeStanding == this.isFreeStanding;
-    }
+        if (isAllBlank) return true;
 
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return 0;
+        if (thisSign.getColor() != thatSign.getColor()) return false;
+        if (thisSign.isGlowing() != thatSign.isGlowing()) return false;
+        for (int i = 0; i < 4; i++) {
+            if (!thisSign.signText[i].equals(thatSign.signText[i])) return false;
+        }
+        return true;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index 3995f8013..42addc6c8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -263,4 +263,26 @@ public class BlockLogicStatue extends BlockLogic {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
+    @Override
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+        assert world.getBlockType(thisPos) == this.block;
+        final var thatBlock = world.getBlockType(thatPos);
+        if (thatBlock != this.block) return false;
+        final var that = (BlockLogicStatue) thatBlock.getLogic();
+
+        final var query = new TilePos();
+        if (!(world.getTileEntity(this.isBottom ? thisPos : thisPos.down(query)) instanceof TileEntityStatue thisStatue) ||
+            !(world.getTileEntity(that.isBottom ? thatPos : thatPos.down(query)) instanceof TileEntityStatue thatStatue))
+            return false;
+        
+        if (thisStatue.getPose() != thatStatue.getPose()) return false;
+        
+        // we assume (but not assert) all stacks to be of size 1
+        // TODO: Item.isEquivalent(ItemStack)
+        if (!ItemStack.areItemsEqual(thisStatue.getHeldItem(), thatStatue.getHeldItem())) return false;
+        for (final var slot : HumanArmorShape.values()) {
+            if (!ItemStack.areItemsEqual(thisStatue.getItemInArmorSlot(slot), thatStatue.getItemInArmorSlot(slot))) return false;
+        }
+        return true;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
index 6358240cf..8af566e81 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
@@ -43,11 +43,10 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable {
             }
 
             int data = world.getBlockData(tilePos);
-            if (data >= 15) {
+            data = (data + 1) & 0xF;
+            world.setBlockData(tilePos, data);
+            if (data == 0) {
                 world.setBlockTypeNotify(up, this.block);
-                world.setBlockDataNotify(tilePos, 0);
-            } else {
-                world.setBlockDataNotify(tilePos, data + 1);
             }
         }
     }
@@ -132,4 +131,9 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable {
         }
         return true;
     }
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        return 0;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
index eb4e1250f..ce20f709a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicThermalVent.java
@@ -26,6 +26,7 @@ public class BlockLogicThermalVent extends BlockLogic {
 
     @Override
     public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
+        if (world.isClientSide) return;
         final int state = getVentState(world.getBlockData(tilePos));
 
         final double xPos = (double) tilePos.x() + 0.5D;
@@ -58,26 +59,32 @@ public class BlockLogicThermalVent extends BlockLogic {
     }
 
     @Override
-    public boolean isEquivalent(final @NotNull World world, final @NotNull TilePosc thisPos, final @NotNull TilePosc thatPos) {
-        return Block.hasLogicClass(world.getBlockType(thatPos), BlockLogicThermalVent.class);
+    protected boolean isSameBlockForMatcher(@NotNull Block<?> other) {
+        return Block.hasLogicClass(other, BlockLogicThermalVent.class);
+    }
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        return 0;
     }
 
     @Override
     public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!hasVentBelow(world, tilePos) && getVentState(world.getBlockData(tilePos)) != DORMANT_STATE) {
-            world.setBlockDataNotify(tilePos, DORMANT_STATE);
+            world.setBlockData(tilePos, DORMANT_STATE);
         }
     }
 
     @Override
     public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+        if (world.isClientSide) return;
         if (world.getBlockType(tilePos.up(new TilePos())).solid()) {
             return;
         }
 
         if (!hasVentBelow(world, tilePos)) {
             if (getVentState(world.getBlockData(tilePos)) != DORMANT_STATE) {
-                world.setBlockDataNotify(tilePos, DORMANT_STATE);
+                world.setBlockData(tilePos, DORMANT_STATE);
             }
             return;
         }
@@ -87,7 +94,7 @@ public class BlockLogicThermalVent extends BlockLogic {
             if (state < VENTING_STATE) {
                 final int buildUpRate = getBuildupRate(world, tilePos, rand);
                 state += buildUpRate;
-                world.setBlockDataNotify(tilePos, state);
+                world.setBlockData(tilePos, state);
             } else {
                 vent(world, tilePos, rand);
             }
@@ -129,12 +136,12 @@ public class BlockLogicThermalVent extends BlockLogic {
         if (!world.isClientSide) {
             alertNearbyPlayers(world, tilePos);
 
-            final List<Entity> entities = world.getEntitiesWithinAABB(Entity.class, new AABBd(tilePos.x() - 1, tilePos.y(), tilePos.z() - 1, tilePos.x() + 1, tilePos.y() + 6, tilePos.z() + 1));
+            final List<Entity> entities = world.getEntitiesWithinAABB(Entity.class, new AABBd(tilePos.x() - 1, tilePos.y(), tilePos.z() - 1, tilePos.x() + 2, tilePos.y() + 7, tilePos.z() + 2));
             for (final @NotNull Entity entity : entities) {
                 entity.fling(0, 2, 0, 1f);
             }
 
-            world.setBlockDataNotify(tilePos, DORMANT_STATE);
+            world.setBlockData(tilePos, DORMANT_STATE);
         }
     }
 
@@ -143,7 +150,7 @@ public class BlockLogicThermalVent extends BlockLogic {
         super.onPlacedByWorld(world, tilePos);
 
         if (!world.isClientSide) {
-            world.setBlockDataNotify(tilePos, hasVentBelow(world, tilePos) ? world.rand.nextInt(VENTING_STATE) : DORMANT_STATE);
+            world.setBlockData(tilePos, hasVentBelow(world, tilePos) ? world.rand.nextInt(VENTING_STATE) : DORMANT_STATE);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
index 9c14af673..64912292e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
@@ -23,12 +23,7 @@ public class BlockLogicTorchRedstone extends BlockLogicTorch {
 
     @Override
     protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        return other.getLogic() instanceof BlockLogicTorchRedstone;
-    }
-
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return this.torchActive ? 1 : 0;
+        return other.getLogic() instanceof BlockLogicTorchRedstone rtorch && rtorch.torchActive == this.torchActive;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index eb0b6a71b..4fc8ef0c6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -45,7 +45,8 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
 
     @Override
     protected int getMatcherEquivalenceData(final int data) {
-        return data & ~(MASK_DIRECTION | MASK_UPPER_HALF);
+        assert (MASK_OPEN << 1) == MASK_UPPER_HALF;
+        return data & ~(MASK_DIRECTION | ((data & MASK_OPEN) << 1));
     }
 
     @Override
